/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.StringReader;
import junit.framework.TestCase;

/**
 *
 * @author bar
 */
public class PostfixEvaluatorImplTest extends TestCase {
    
    public PostfixEvaluatorImplTest(String testName) {
        super(testName);
    }            

    @Override
    protected void setUp() throws Exception {
        super.setUp();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    /**
     * Test of evaluate method, of class PostfixEvaluatorImpl.
     */
    
    public void testEvaluate() throws Exception {
        System.out.println("evaluate");
        StringReader expr1=new StringReader("1 2 + 3 /");
        PostfixEvaluatorImpl instance = new PostfixEvaluatorImpl(expr1);
        double expResult = 1.0;
        double result=0.0;
        
        try{
            result = instance.evaluate();
        }
        catch(Exception e){
            e.printStackTrace();
            fail("Nastala neocekavana vyjimka");
        }
        assertEquals("Spatny vysledek",expResult,result);
        
        try{
            instance = new PostfixEvaluatorImpl(null);
            fail("Nevyvolana PostfixException pri in = null");
        }catch(PostfixException ex){
        }

        StringReader expr2=new StringReader("1 2 + 3 4 + 4 -");
        instance = new PostfixEvaluatorImpl(expr2);
        try{
            result = instance.evaluate();
            fail("Mela nastat PostfixException - nekorektni vyraz. Je vysledek:"+result);
        }catch(PostfixException ok){
            ok.printStackTrace();
        }
        
        expr1 = new StringReader("1 3 * 5 5 / + 2 -");
        instance = new PostfixEvaluatorImpl(expr1);
        try{
            result = instance.evaluate();
        }catch(Exception e){
            fail("Nastala neocekavana vyjimka"+e);
        }
        assertEquals("Spatny vysledek",2.0,result);
        
        
        expr1 = new StringReader("a 1 + 4 5 + *");
        try{
            instance = new PostfixEvaluatorImpl(expr1);
        }catch(PostfixException ex){
            fail("Neocekavana vyjimka v konstruktoru");
        }
        
        try{
            result = instance.evaluate();
            fail("Zpracuje vyraz"+expr1.toString());
        }catch(PostfixException ex){
        }
        
        expr1 = new StringReader("a 1 + 4 5 + *2");
        try{
            instance = new PostfixEvaluatorImpl(expr1);
        }catch(PostfixException ex){
            fail("Neocekavana vyjimka v konstruktoru");
        }
        
        try{
            result = instance.evaluate();
            fail("Zpracuje vyraz"+expr1.toString());
        }catch(PostfixException ex){
        }
      //  assertEquals(expResult, result);
        // TODO review the generated test code and remove the default call to fail.
//        fail("The test case is a prototype.");
    }

}
